package pipe.gui;

import pipe.dataLayer.*;
import javax.swing.*;
import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Event.*;
import java.awt.event.*;
import java.awt.event.WindowEvent;
import java.io.*;
import java.awt.Color;
import java.util.*;
import java.io.File;
import org.xml.sax.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import java.awt.print.*;
import javax.swing.AbstractAction;
import javax.swing.*;
import javax.swing.JInternalFrame;
import java.awt.*;
import java.awt.event.*;


public class AnimateAction extends AbstractAction implements Constants, ActionListener{
  private int typeID;
  private String imageFileName;
  private String selectedFileName;
  private CreateGui theApp;
  private AnimationHistory animBox ;




  AnimateAction( CreateGui theApp,String name, int typeID, String tooltip){
    super(name);
    this.theApp = theApp;

    this.typeID = typeID;

    if(tooltip != null)
      putValue(SHORT_DESCRIPTION, tooltip);



    switch(typeID){
      case START:
        imageFileName = "Images/startAnimation.gif";
        selectedFileName= "Images/startAnimation2.gif";

        break;
      case STOP:
        imageFileName = "Images/stopAnimation.gif";
        selectedFileName = "Images/stopAnimation2.gif";

        break;
      case FIRE:
        imageFileName = "Images/fireAnimation.gif";
        selectedFileName = "Images/fireAnimation2.gif";
        break;

      case STEPFORWARD:
        imageFileName = "Images/stepforwardAnimation.gif";
        selectedFileName = "Images/stepforwardAnimation2.gif";
        break;
      case STEPBACKWARD:
        imageFileName = "Images/stepbackwardAnimation.gif";
        selectedFileName = "Images/stepbackwardAnimation2.gif";
        break;
      case RANDOM:
        imageFileName = "Images/randomAnimation.gif";
        selectedFileName = "Images/randomAnimation2.gif";
        break;
      default: return;
    }

    if(new File(imageFileName).exists()){
      putValue(SMALL_ICON, new ImageIcon(imageFileName));
    }

  }

  public void actionPerformed(ActionEvent e){
    theApp.getApp().setpnobjectType(typeID);
    ModeAdaptor.setMode(typeID);



    animBox = theApp.getAnimationHistory();
     /* if (animBox==null)
        System.out.println("animbox is null");*/


    switch(typeID){
      case START:
        theApp.getApp().getStatusBar().changeText(" Animation Mode: Red transitions are enabled, click a transition to fire it");
        theApp.getView().changeAnimationMode(true);
        theApp.getAnimator().storeModel();

        theApp.currentPNMLData().setEnabledTransitions();

        theApp.getAnimator().highlightEnabledTransitions();
        theApp.getApp().enableActions(false);//disables all non-animation buttons
        theApp.addAnimationHistory();
        break;

      case FIRE:

        break;

      case STOP:

        theApp.getApp().enableActions(true); //renables all non-animation buttons
        theApp.getApp().getStatusBar().changeText(" Drawing Mode: Click on a button to start adding components to the editor ");
        theApp.getView().changeAnimationMode(false);
        theApp.getAnimator().restoreModel();
        theApp.removeAnimationHistory();
        theApp.getApp().setallDefault();  //sets all buttons to default

        break;

      case RANDOM: theApp.currentPNMLData().setEnabledTransitions();
//		 int numberSequences = getnumberSequences();

        theApp.getAnimator().startRandomFiring(1);

        break;

      case STEPFORWARD:
        animBox.stepForward();
        theApp.getAnimator().stepForward();
        break;

      case STEPBACKWARD:
        animBox.stepBackwards();
        theApp.getAnimator().stepBack();

        break;
      default:
        return;
    }

  }

  public int getnumberSequences(){
    String sequence ="";
    sequence  = JOptionPane.showInputDialog("Enter number of sequences for random firing", sequence);
    int numSequences = Integer.parseInt(sequence);
    return numSequences;

  }

  public void numberstepsBack(){
  }
}










